Index: palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4517)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+! 
+! 4502 2020-04-17 16:14:16Z schwenkel
 ! Implementation of ice microphysics
 ! 
@@ -147,5 +150,5 @@
 
    USE restart_data_mpi_io_mod,                                                                    &
-       ONLY:  rrd_mpi_io, wrd_mpi_io
+       ONLY:  rd_mpi_io_check_array, rrd_mpi_io, wrd_mpi_io
 
    USE surface_mod,                                                                                &
@@ -267,5 +270,6 @@
 
    INTERFACE  surface_data_output_rrd_local
-      MODULE PROCEDURE surface_data_output_rrd_local
+      MODULE PROCEDURE surface_data_output_rrd_local_ftn
+      MODULE PROCEDURE surface_data_output_rrd_local_mpi
    END INTERFACE  surface_data_output_rrd_local
 
@@ -4883,7 +4887,7 @@
 ! Description:
 ! ------------
-!> This routine reads the respective restart data.
+!> Read module-specific local restart data arrays (Fortran binary format).
 !------------------------------------------------------------------------------!
-    SUBROUTINE surface_data_output_rrd_local( found )
+    SUBROUTINE surface_data_output_rrd_local_ftn( found )
 
 
@@ -4895,7 +4899,5 @@
        LOGICAL, INTENT(OUT)  ::  found
 
-!
-!--    Here the reading of user-defined restart data follows:
-!--    Sample for user-defined output
+
        found = .TRUE.
 
@@ -4912,5 +4914,29 @@
 
 
-    END SUBROUTINE surface_data_output_rrd_local
+    END SUBROUTINE surface_data_output_rrd_local_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (MPI-IO).
+!------------------------------------------------------------------------------!
+    SUBROUTINE surface_data_output_rrd_local_mpi
+
+       IMPLICIT NONE
+
+       LOGICAL ::  array_found  !<
+
+
+       CALL rd_mpi_io_check_array( 'surfaces%var_av' , found = array_found )
+
+!> does not work this way: surface%var_av has non-standard dimensions
+!       IF ( array_found )  THEN
+!          IF ( .NOT. ALLOCATED( surfaces%var_av ) )  ALLOCATE( ....... )
+!          CALL rrd_mpi_io( 'surfaces%var_av', surfaces%var_av )
+!       ENDIF
+
+    END SUBROUTINE surface_data_output_rrd_local_mpi
+
 
 !------------------------------------------------------------------------------!
@@ -4936,4 +4962,5 @@
     END SUBROUTINE surface_data_output_wrd_global
 
+
 !------------------------------------------------------------------------------!
 ! Description:
Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 4517)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+! 
+! 4502 2020-04-17 16:14:16Z schwenkel
 ! Implementation of ice microphysics
 ! 
@@ -145,5 +148,6 @@
 
     USE restart_data_mpi_io_mod,                                                                   &
-        ONLY:  rd_mpi_io_surface_filetypes, total_number_of_surface_values, wrd_mpi_io,            &
+        ONLY:  rd_mpi_io_surface_filetypes, rrd_mpi_io, rrd_mpi_io_global_array,                   &
+               rrd_mpi_io_surface, total_number_of_surface_values, wrd_mpi_io,                     &
                wrd_mpi_io_global_array, wrd_mpi_io_surface
 
@@ -499,5 +503,6 @@
 
     INTERFACE surface_rrd_local
-       MODULE PROCEDURE surface_rrd_local
+       MODULE PROCEDURE surface_rrd_local_ftn
+       MODULE PROCEDURE surface_rrd_local_mpi
     END INTERFACE surface_rrd_local
 
@@ -4236,5 +4241,5 @@
 ! Description:
 ! ------------
-!> Reads surface-related restart data. Please note, restart data for a certain
+!> Reads surface-related restart data in Fortran binary format. Please note, restart data for a certain
 !> surface orientation (e.g. horizontal upward-facing) is stored in one
 !> array, even if surface elements may belong to different surface types
@@ -4244,7 +4249,7 @@
 !> of cyclic_fill mode.
 !------------------------------------------------------------------------------!
-    SUBROUTINE surface_rrd_local( kk, nxlf, nxlc, nxl_on_file, nxrf,           &
-                                  nxr_on_file, nynf, nyn_on_file, nysf,        &
-                                  nysc, nys_on_file, found )
+    SUBROUTINE surface_rrd_local_ftn( kk, nxlf, nxlc, nxl_on_file, nxrf,           &
+                                      nxr_on_file, nynf, nyn_on_file, nysf,        &
+                                      nysc, nys_on_file, found )
 
 
@@ -5185,6 +5190,5 @@
        ENDIF
 
-
-    CONTAINS
+ CONTAINS
 !------------------------------------------------------------------------------!
 ! Description:
@@ -5403,5 +5407,450 @@
 
 
-    END SUBROUTINE surface_rrd_local
+    END SUBROUTINE surface_rrd_local_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Reads surface-related restart data in MPI-IO format.
+!> TO_DO: this routine needs to be adjusted for cyclic_fill mode
+!------------------------------------------------------------------------------!
+ SUBROUTINE surface_rrd_local_mpi
+
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=1) ::  dum  !< dummy string to create input-variable name
+
+    INTEGER(iwp) ::  l  !< loop index for surface types
+
+    INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  global_start_index  !< index for surface data (MPI-IO)
+
+    LOGICAL ::  ldum  !< dummy variable
+
+    TYPE(surf_type), DIMENSION(0:2) ::  surf_h     !< gathered horizontal surfaces, contains all surface types
+    TYPE(surf_type), DIMENSION(0:3) ::  surf_v     !< gathered vertical surfaces, contains all surface types
+
+!
+!-- Get total number of surface points on the file
+    CALL rrd_mpi_io_global_array( 'ns_h_on_file', ns_h_on_file )
+    CALL rrd_mpi_io_global_array( 'ns_v_on_file', ns_v_on_file )
+
+
+    DO  l = 0, 2
+
+       IF ( ns_h_on_file(l) == 0 )  CYCLE  !< no data of this surface type on file
+
+       IF ( ALLOCATED( surf_h(l)%start_index ) )  CALL deallocate_surface_attributes_h( surf_h(l) )
+       surf_h(l)%ns = ns_h_on_file(l)
+       CALL allocate_surface_attributes_h( surf_h(l), nys, nyn, nxl, nxr )
+
+       WRITE( dum, '(I1)')  l
+
+       CALL rrd_mpi_io( 'surf_h(' // dum // ')%start_index',  surf_h(l)%start_index )
+       CALL rrd_mpi_io( 'surf_h(' // dum // ')%end_index',  surf_h(l)%end_index )
+       CALL rrd_mpi_io( 'global_start_index_h_' // dum , global_start_index )
+
+       CALL rd_mpi_io_surface_filetypes( surf_h(l)%start_index, surf_h(l)%end_index, ldum, global_start_index )
+
+       IF ( ALLOCATED ( surf_h(l)%us ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%us', surf_h(l)%us )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%ts ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%ts', surf_h(l)%ts )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%qs ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%qs', surf_h(l)%qs )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%ss ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%ss', surf_h(l)%ss )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%qcs ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%qcs', surf_h(l)%qcs )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%ncs ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%ncs', surf_h(l)%ncs )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%qis ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%qis', surf_h(l)%qis )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%nis ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%nis', surf_h(l)%nis )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%qrs ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%qrs', surf_h(l)%qrs )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%nrs ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%nrs', surf_h(l)%nrs )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%ol ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%ol', surf_h(l)%ol )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%rib ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%rib',  surf_h(l)%rib )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%pt_surface ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%pt_surface', surf_h(l)%pt_surface )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%q_surface ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%q_surface', surf_h(l)%q_surface )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%vpt_surface ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%vpt_surface', surf_h(l)%vpt_surface )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%usws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%usws', surf_h(l)%usws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%vsws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%vsws', surf_h(l)%vsws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%shf ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%shf', surf_h(l)%shf )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%qsws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%qsws', surf_h(l)%qsws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%ssws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%ssws', surf_h(l)%ssws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%css ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%css', surf_h(l)%css )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%cssws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%cssws', surf_h(l)%cssws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%qcsws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%qcsws', surf_h(l)%qcsws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%ncsws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%ncsws', surf_h(l)%ncsws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%qisws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%qisws', surf_h(l)%qisws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%nisws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%nisws', surf_h(l)%nisws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%qrsws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%qrsws', surf_h(l)%qrsws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%nrsws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%nrsws', surf_h(l)%nrsws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_h(l)%sasws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_h(' // dum // ')%sasws', surf_h(l)%sasws )
+       ENDIF
+
+    ENDDO
+
+!
+!-- Read vertical surfaces
+    DO  l = 0, 3
+
+       IF ( ns_v_on_file(l) == 0 )  CYCLE  !< no data of this surface type on file
+
+       IF ( ALLOCATED( surf_v(l)%start_index ) )  CALL deallocate_surface_attributes_v( surf_v(l) )
+       surf_v(l)%ns = ns_v_on_file(l)
+       CALL allocate_surface_attributes_v( surf_v(l), nys, nyn, nxl, nxr )
+
+       WRITE( dum, '(I1)' )  l
+
+       CALL rrd_mpi_io( 'surf_v(' // dum // ')%start_index', surf_v(l)%start_index )
+       CALL rrd_mpi_io( 'surf_v(' // dum // ')%end_index', surf_v(l)%end_index )
+       CALL rrd_mpi_io( 'global_start_index_v_' // dum , global_start_index )
+
+       CALL rd_mpi_io_surface_filetypes( surf_v(l)%start_index, surf_v(l)%end_index, ldum,         &
+                                         global_start_index )
+
+       IF ( ALLOCATED ( surf_v(l)%us ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%us',  surf_v(l)%us )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%ts ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%ts', surf_v(l)%ts )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%qs ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%qs',  surf_v(l)%qs )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%ss ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%ss',  surf_v(l)%ss )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%qcs ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%qcs', surf_v(l)%qcs )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%ncs ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%ncs', surf_v(l)%ncs )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%qis ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%qis', surf_v(l)%qis )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%nis ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%nis', surf_v(l)%nis )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%qrs ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%qrs', surf_v(l)%qrs )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%nrs ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%nrs', surf_v(l)%nrs )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%ol ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%ol', surf_v(l)%ol )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%rib ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%rib', surf_v(l)%rib )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%pt_surface ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%pt_surface', surf_v(l)%pt_surface )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%q_surface ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%q_surface', surf_v(l)%q_surface )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%vpt_surface ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%vpt_surface', surf_v(l)%vpt_surface )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%shf ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%shf', surf_v(l)%shf )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%qsws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%qsws', surf_v(l)%qsws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%ssws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%ssws', surf_v(l)%ssws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%css ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%css', surf_v(l)%css )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%cssws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%cssws', surf_v(l)%cssws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%qcsws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%qcsws', surf_v(l)%qcsws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%ncsws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%ncsws', surf_v(l)%ncsws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%qisws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%qisws', surf_v(l)%qisws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%nisws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%nisws', surf_v(l)%nisws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%qrsws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%qrsws', surf_v(l)%qrsws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%nrsws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%nrsws', surf_v(l)%nrsws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%sasws ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%sasws', surf_v(l)%sasws )
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%mom_flux_uv ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%mom_uv', surf_v(l)%mom_flux_uv)
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%mom_flux_w ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%mom_w',  surf_v(l)%mom_flux_w)
+       ENDIF
+
+       IF ( ALLOCATED ( surf_v(l)%mom_flux_tke ) )  THEN
+          CALL rrd_mpi_io_surface( 'surf_v(' // dum // ')%mom_tke', surf_v(l)%mom_flux_tke)
+       ENDIF
+
+    ENDDO
+
+!
+!-- Redistribute surface elements on its respective type.
+
+    DO  l = 0 , 2
+       CALL restore_surface_elements( surf_def_h(l), surf_h(l) )
+       CALL restore_surface_elements( surf_lsm_h, surf_h(l) )
+       CALL restore_surface_elements( surf_usm_h, surf_h(l) )
+    ENDDO
+
+    DO  l = 0 , 3
+       CALL restore_surface_elements( surf_def_v(l), surf_v(l) )
+       CALL restore_surface_elements( surf_lsm_v(l), surf_v(l) )
+       CALL restore_surface_elements( surf_usm_v(l), surf_v(l) )
+    ENDDO
+
+ CONTAINS
+
+          SUBROUTINE restore_surface_elements( surf_target, surf_file )
+
+             IMPLICIT NONE
+
+             INTEGER(iwp)      ::  lsp         !< running index chemical species
+
+             TYPE( surf_type ) ::  surf_target !< target surface type
+             TYPE( surf_type ) ::  surf_file   !< surface type on file
+
+
+             IF ( ALLOCATED( surf_target%us )  .AND. ALLOCATED( surf_file%us   ) )      THEN
+                surf_target%us = surf_file%us
+             ENDIF
+
+             IF ( ALLOCATED( surf_target%ol )  .AND.                        &
+                ALLOCATED( surf_file%ol   ) )                             &
+                surf_target%ol = surf_file%ol
+
+             IF ( ALLOCATED( surf_target%pt_surface )  .AND.                &
+                ALLOCATED( surf_file%pt_surface   ) )                     &
+                surf_target%pt_surface = surf_file%pt_surface
+
+             IF ( ALLOCATED( surf_target%q_surface )  .AND.                 &
+                ALLOCATED( surf_file%q_surface   ) )                      &
+                surf_target%q_surface = surf_file%q_surface
+
+             IF ( ALLOCATED( surf_target%vpt_surface )  .AND.               &
+                ALLOCATED( surf_file%vpt_surface   ) )                    &
+                surf_target%vpt_surface = surf_file%vpt_surface
+
+             IF ( ALLOCATED( surf_target%usws )  .AND.                      &
+                ALLOCATED( surf_file%usws   ) )                           &
+                surf_target%usws = surf_file%usws
+
+             IF ( ALLOCATED( surf_target%vsws )  .AND.                      &
+                ALLOCATED( surf_file%vsws   ) )                           &
+                surf_target%vsws = surf_file%vsws
+
+             IF ( ALLOCATED( surf_target%ts )  .AND.                        &
+                ALLOCATED( surf_file%ts   ) )                             &
+                surf_target%ts = surf_file%ts
+
+             IF ( ALLOCATED( surf_target%shf )  .AND.                       &
+                ALLOCATED( surf_file%shf   ) )                            &
+                surf_target%shf = surf_file%shf
+
+             IF ( ALLOCATED( surf_target%qs )  .AND.                        &
+                ALLOCATED( surf_file%qs   ) )                             &
+                surf_target%qs = surf_file%qs
+
+             IF ( ALLOCATED( surf_target%qsws )  .AND.                      &
+                ALLOCATED( surf_file%qsws   ) )                           &
+                surf_target%qsws = surf_file%qsws
+
+             IF ( ALLOCATED( surf_target%ss )  .AND.                        &
+                ALLOCATED( surf_file%ss   ) )                             &
+                surf_target%ss = surf_file%ss
+
+             IF ( ALLOCATED( surf_target%ssws )  .AND.                      &
+                ALLOCATED( surf_file%ssws   ) )                           &
+                surf_target%ssws = surf_file%ssws
+
+             IF ( ALLOCATED( surf_target%css )  .AND.                     &
+                ALLOCATED( surf_file%css   ) )  THEN
+                DO  lsp = 1, nvar
+                   surf_target%css(lsp,:) = surf_file%css(lsp,:)
+                ENDDO
+             ENDIF
+
+             IF ( ALLOCATED( surf_target%cssws )  .AND.                     &
+                ALLOCATED( surf_file%cssws   ) )  THEN
+                DO  lsp = 1, nvar
+                   surf_target%cssws(lsp,:) = surf_file%cssws(lsp,:)
+                ENDDO
+             ENDIF
+             IF ( ALLOCATED( surf_target%qcs )  .AND.                       &
+                ALLOCATED( surf_file%qcs   ) )                            &
+                surf_target%qcs = surf_file%qcs
+             IF ( ALLOCATED( surf_target%qcsws )  .AND.                     &
+                ALLOCATED( surf_file%qcsws   ) )                          &
+                surf_target%qcsws = surf_file%qcsws
+             IF ( ALLOCATED( surf_target%ncs )  .AND.                       &
+                ALLOCATED( surf_file%ncs   ) )                            &
+                surf_target%ncs = surf_file%ncs
+             IF ( ALLOCATED( surf_target%ncsws )  .AND.                     &
+                ALLOCATED( surf_file%ncsws   ) )                          &
+                surf_target%ncsws = surf_file%ncsws
+             IF ( ALLOCATED( surf_target%qrs )  .AND.                       &
+                ALLOCATED( surf_file%qrs   ) )                            &
+                surf_target%qrs = surf_file%qrs
+             IF ( ALLOCATED( surf_target%qrsws )  .AND.                     &
+                ALLOCATED( surf_file%qrsws   ) )                          &
+                surf_target%qrsws = surf_file%qrsws
+             IF ( ALLOCATED( surf_target%nrs )  .AND.                       &
+                ALLOCATED( surf_file%nrs   ) )                            &
+                surf_target%nrs = surf_file%nrs
+
+             IF ( ALLOCATED( surf_target%nrsws )  .AND.                     &
+                ALLOCATED( surf_file%nrsws   ) )                          &
+                surf_target%nrsws = surf_file%nrsws
+             IF ( ALLOCATED( surf_target%sasws )  .AND.                     &
+                ALLOCATED( surf_file%sasws   ) )                          &
+                surf_target%sasws = surf_file%sasws
+             IF ( ALLOCATED( surf_target%mom_flux_uv )  .AND.               &
+                ALLOCATED( surf_file%mom_flux_uv   ) )                    &
+                surf_target%mom_flux_uv =                         &
+                surf_file%mom_flux_uv
+             IF ( ALLOCATED( surf_target%mom_flux_w )  .AND.                &
+                ALLOCATED( surf_file%mom_flux_w   ) )                     &
+                surf_target%mom_flux_w =                          &
+                surf_file%mom_flux_w
+             IF ( ALLOCATED( surf_target%mom_flux_tke )  .AND.              &
+                ALLOCATED( surf_file%mom_flux_tke   ) )                   &
+                surf_target%mom_flux_tke(0:1,:) =                    &
+                surf_file%mom_flux_tke(0:1,:)
+
+
+          END SUBROUTINE restore_surface_elements
+
+ END SUBROUTINE surface_rrd_local_mpi
+
+
+
 
 
Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4517)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+! 
+! 4510 2020-04-29 14:19:18Z raasch
 ! Further re-formatting to follow the PALM coding standard
 !
@@ -368,4 +371,6 @@
     USE restart_data_mpi_io_mod,                                                                   &
         ONLY:  rd_mpi_io_surface_filetypes,                                                        &
+               rrd_mpi_io,                                                                         &
+               rrd_mpi_io_surface,                                                                 &
                wrd_mpi_io,                                                                         &
                wrd_mpi_io_surface
@@ -617,6 +622,4 @@
 
 
-
-
 !
 !-- Building facade/wall/green/window properties (partly according to PIDS).
@@ -840,5 +843,6 @@
 
     INTERFACE usm_rrd_local
-       MODULE PROCEDURE usm_rrd_local
+       MODULE PROCEDURE usm_rrd_local_ftn
+       MODULE PROCEDURE usm_rrd_local_mpi
     END INTERFACE usm_rrd_local
 
@@ -6110,8 +6114,9 @@
 ! Description:
 ! ------------
-!> Soubroutine reads t_surf and t_wall data from restart files
+!> Read module-specific local restart data arrays (Fortran binary format).
+!> Soubroutine reads t_surf and t_wall.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE usm_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxr_on_file, nynf, nyn_on_file,       &
-                           nysf, nysc, nys_on_file, found )
+ SUBROUTINE usm_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxr_on_file, nynf, nyn_on_file,   &
+                               nysf, nysc, nys_on_file, found )
 
 
@@ -6654,5 +6659,120 @@
     END SELECT
 
- END SUBROUTINE usm_rrd_local
+ END SUBROUTINE usm_rrd_local_ftn
+
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (MPI-IO).
+!> Soubroutine reads t_surf and t_wall.
+!>
+!> This read routine is a counterpart of usm_wrd_local.
+!> In usm_wrd_local, all array are unconditionally written, therefore all arrays are read here.
+!> This is a preliminary version of reading usm data. The final version has to be discussed with
+!> the developers.
+!>
+!> If it is possible to call usm_allocate_surface before reading the restart file, this reading
+!> routine would become much simpler, because no checking for allocation will be necessary any more.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE usm_rrd_local_mpi
+
+
+    CHARACTER(LEN=1) ::  dum  !< dummy string to create input-variable name
+
+    INTEGER(iwp) ::  l  !< loop index for surface types
+
+    INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  global_start
+
+    LOGICAL ::  ldum  !< dummy variable
+
+
+    CALL rrd_mpi_io( 'usm_start_index_h',  surf_usm_h%start_index )
+    CALL rrd_mpi_io( 'usm_end_index_h', surf_usm_h%end_index )
+    CALL rrd_mpi_io( 'usm_global_start_h', global_start )
+
+    CALL rd_mpi_io_surface_filetypes( surf_usm_h%start_index, surf_usm_h%end_index, ldum,          &
+                                      global_start )
+
+    IF ( .NOT.  ALLOCATED( t_surf_wall_h_1 ) )  ALLOCATE( t_surf_wall_h_1(1:surf_usm_h%ns) )
+    CALL rrd_mpi_io_surface( 't_surf_wall_h', t_surf_wall_h_1 )
+
+    IF ( .NOT.  ALLOCATED( t_surf_window_h_1 ) )  ALLOCATE( t_surf_window_h_1(1:surf_usm_h%ns) )
+    CALL rrd_mpi_io_surface( 't_surf_window_h', t_surf_window_h_1 )
+
+    IF ( .NOT.  ALLOCATED( t_surf_green_h_1 ) )  ALLOCATE( t_surf_green_h_1(1:surf_usm_h%ns) )
+    CALL rrd_mpi_io_surface( 't_surf_green_h', t_surf_green_h_1 )
+
+    DO  l = 0, 3
+
+       WRITE( dum, '(I1)' )  l
+
+       CALL rrd_mpi_io( 'usm_start_index_v_' //dum, surf_usm_v(l)%start_index )
+       CALL rrd_mpi_io( 'usm_end_index_v_' // dum, surf_usm_v(l)%end_index )
+       CALL rrd_mpi_io( 'usm_global_start_v_' // dum, global_start )
+
+       CALL rd_mpi_io_surface_filetypes( surf_usm_v(l)%start_index, surf_usm_v(l)%end_index, ldum, &
+                                         global_start )
+
+       IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(l)%t ) )                                             &
+          ALLOCATE( t_surf_wall_v_1(l)%t(1:surf_usm_v(l)%ns) )
+       CALL rrd_mpi_io_surface( 't_surf_wall_v(' // dum // ')', t_surf_wall_v_1(l)%t )
+
+       IF ( .NOT.  ALLOCATED( t_surf_window_v_1(l)%t ) )                                           &
+          ALLOCATE( t_surf_window_v_1(l)%t(1:surf_usm_v(l)%ns) )
+       CALL rrd_mpi_io_surface( 't_surf_window_v(' // dum // ')', t_surf_window_v_1(l)%t )
+
+       IF ( .NOT.  ALLOCATED( t_surf_green_v_1(l)%t ) )                                            &
+          ALLOCATE( t_surf_green_v_1(l)%t(1:surf_usm_v(l)%ns) )
+       CALL rrd_mpi_io_surface( 't_surf_green_v(' // dum // ')', t_surf_green_v_1(l)%t)
+
+    ENDDO
+
+    CALL rrd_mpi_io( 'usm_start_index_h_2',  surf_usm_h%start_index )
+    CALL rrd_mpi_io( 'usm_end_index_h_2', surf_usm_h%end_index )
+    CALL rrd_mpi_io( 'usm_global_start_h_2', global_start )
+
+    CALL rd_mpi_io_surface_filetypes( surf_usm_h%start_index, surf_usm_h%end_index, ldum,          &
+                                      global_start )
+
+    IF ( .NOT.  ALLOCATED( t_wall_h_1 ) )                                                          &
+       ALLOCATE( t_wall_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+    CALL rrd_mpi_io_surface( 't_wall_h', t_wall_h_1 )
+
+    IF ( .NOT.  ALLOCATED( t_window_h_1 ) )                                                        &
+       ALLOCATE( t_window_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+    CALL rrd_mpi_io_surface( 't_window_h', t_window_h_1 )
+
+    IF ( .NOT.  ALLOCATED( t_green_h_1 ) )                                                         &
+       ALLOCATE( t_green_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+    CALL rrd_mpi_io_surface( 't_green_h', t_green_h_1 )
+
+    DO  l = 0, 3
+
+       WRITE( dum, '(I1)' )  l
+
+       CALL rrd_mpi_io( 'usm_start_index_v_2_' //dum, surf_usm_v(l)%start_index )
+       CALL rrd_mpi_io( 'usm_end_index_v_2_' // dum, surf_usm_v(l)%end_index )
+       CALL rrd_mpi_io( 'usm_global_start_v_2_' // dum, global_start )
+
+       CALL rd_mpi_io_surface_filetypes( surf_usm_v(l)%start_index, surf_usm_v(l)%end_index, ldum, &
+                                         global_start )
+
+       IF ( .NOT. ALLOCATED( t_wall_v_1(l)%t ) )                                                   &
+          ALLOCATE ( t_wall_v_1(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+       CALL rrd_mpi_io_surface( 't_wall_v(' // dum // ')', t_wall_v_1(l)%t )
+
+       IF ( .NOT. ALLOCATED( t_window_v_1(l)%t ) )                                                 &
+          ALLOCATE ( t_window_v_1(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+       CALL rrd_mpi_io_surface( 't_window_v(' // dum // ')', t_window_v_1(l)%t )
+
+       IF ( .NOT. ALLOCATED( t_green_v_1(l)%t ) )                                                  &
+          ALLOCATE ( t_green_v_1(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+       CALL rrd_mpi_io_surface( 't_green_v(' // dum // ')', t_green_v_1(l)%t )
+
+    ENDDO
+
+ END SUBROUTINE usm_rrd_local_mpi
+
 
 
